<?php

/*****************************************************************************************
 * X2Engine Open Source Edition is a customer relationship management program developed by
 * X2Engine, Inc. Copyright (C) 2011-2015 X2Engine Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by the
 * Free Software Foundation with the addition of the following permission added
 * to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED WORK
 * IN WHICH THE COPYRIGHT IS OWNED BY X2ENGINE, X2ENGINE DISCLAIMS THE WARRANTY
 * OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License along with
 * this program; if not, see http://www.gnu.org/licenses or write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * 
 * You can contact X2Engine, Inc. P.O. Box 66752, Scotts Valley,
 * California 95067, USA. or at email address contact@x2engine.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License version 3,
 * these Appropriate Legal Notices must retain the display of the "Powered by
 * X2Engine" logo. If the display of the logo is not reasonably feasible for
 * technical reasons, the Appropriate Legal Notices must display the words
 * "Powered by X2Engine".
 *****************************************************************************************/



?>
<div class="page-title"><h2><?php echo Yii::t('admin', 'Public Info Settings'); ?></h2></div>
<div class="admin-form-container">
    <?php
    $form = $this->beginWidget('CActiveForm', array(
        'id' => 'settings-form',
        'enableAjaxValidation' => false,
            ));
    ?>
    <div class="form">
        <?php echo $form->labelEx($model, 'externalBaseUrl'); ?><br />
        <p><?php 
        echo Yii::t('admin', 'This will be the web root URL to use for generating URLs to '.
            'public-facing resources, i.e. email tracking images, the web tracker, targeted '.
            'content etc.');
        ?></p>
        <?php

?>
        <p><?php 
        echo Yii::t('admin', 'You ');
         
        echo Yii::t('admin', 'should use this if the CRM is behind a firewall and you access X2Engine using a different URL than one would use to access it from the internet (i.e. a host name / IP address on a private subnet or VPN).'); 
        ?></p>
        <?php echo $form->textField($model, 'externalBaseUrl',array('style' => 'width: 90%')); ?>
        <?php echo CHtml::error($model, 'externalBaseUrl');?>

        <br /><br />
        
        <?php echo $form->labelEx($model,'externalBaseUri'); ?><br />
        <p><?php echo Yii::t('admin','If the relative path from the web root differs between how you are accessing it now and how it will be accessed through public-facing URLs, enter it here. For example, if the CRM is accessed within {samplePrivateUrl}, and public assets will be accessed within {samplePublicUrl}, set this value to {samplePublicUri}.',array(
            '{samplePrivateUrl}' => 'http://internaldomain.net/x2',
            '{samplePublicUrl}' => 'http://publicsite.com/crm',
            '{samplePublicUri}' => '/crm'
        )) ?></p>
        <?php echo $form->textField($model,'externalBaseUri'); ?>
        <?php echo CHtml::error($model, 'externalBaseUri');?>
<?php

?>
    </div><!-- .form -->

    <?php echo CHtml::submitButton(Yii::t('app', 'Save'), array('class' => 'x2-button', 'id' => 'save-button'))."\n"; ?>
    <?php $this->endWidget(); ?>
</div><!-- .span-16 -->
